import { Context } from 'koa';
import services from '../services';
interface sessionInterface {
  user?: string
}

const home = async (ctx: Context) => {
  ctx.body = 'home';
};

const code = async (ctx: Context) => {
  interface params {
    phone?: string
  }
  const params: params = {}
  params.phone = ctx.query.phone
  if (!params.phone) {
    ctx.status = 400;
    ctx.body = ctx.$response(null, 'phone参数缺失', false);
    return;
  };
  const body = await services.code(ctx, params);
  ctx.body = ctx.$response(body);
};

const login = async (ctx: Context) => {
  const { username, password } = ctx.request.body
  if (!username) {
    ctx.body = ctx.$response(null, '用户名不能为空', false)
    return
  }
  if (!password) {
    ctx.body = ctx.$response(null, '密码不能为空', false)
    return
  }
  const dbInfo = {
    username: 'zhusiqing',
    password: '123456'
  }
  if (username === dbInfo.username && password === dbInfo.password) {
    if (ctx.session) {
      if (ctx.session.user) {
        ctx.body = ctx.$response(null, '用户已登录', true)
        return
      }
      ctx.session.user = username
    }
    ctx.body = ctx.$response({ username }, '登录成功', true)
  } else {
    ctx.body = ctx.$response(null, '用户名或者密码错误', false)
  }
}

const logout = async (ctx: Context) => {
  if (ctx.session) {
    ctx.session.user = null
  }
  ctx.body = ctx.$response(null, '退出成功')
}

const userInfo = async (ctx: Context) => {
  if (!ctx.session || !ctx.session.user ) {
    ctx.body = ctx.$response(null, '未登录', false, 400000)
    return
  }
  const session: sessionInterface = ctx.session.toJSON()
  ctx.body = ctx.$response({ username: session.user })
}

export default {
  home,
  code,
  login,
  logout,
  userInfo
}
