class Observer {
  public handle
  constructor() {
    this.handle = {};
  };
  // 注册监听的事件
  on(type = '', callback: Function) {
    // 校验参数
    if (typeof type !== 'string') {
      const msg = `on type must is string, now is ${Object.prototype.toString.call(type)}`;
      throw new Error(msg);
    };
    if (typeof callback !== 'function') {
      const msg = `callback must is function, now is ${Object.prototype.toString.call(callback)}`;
      throw new Error(msg);
    };
    // 添加监听的事件，同一个事件可以多个函数监听
    if (this.handle[type] !== '[object Array]') {
      this.handle[type] = [];
    };
    this.handle[type].push(callback);
  };
  // 触发
  emit(type = '', ...params) {
    if (typeof type !== 'string') {
      const msg = `emit type must is string, now is ${Object.prototype.toString.call(type)}`;
      throw new Error(msg);
    };
    if (!this.handle[type]) {
      const msg = `${type} is not exist`;
      throw new Error(msg);
    };
    const forHandle = (el) => {
      if (Object.prototype.toString.call(el) === '[object Function]') {
        el(...params);
      } else {
        throw new Error(`${type} is not function`);
      };
    }
    this.handle[type].forEach(forHandle.bind(this));
  }
  // 销毁监听的事件
  destory(type = '') {
    if (typeof type !== 'string') {
      const msg = `emit type must is string, now is ${Object.prototype.toString.call(type)}`;
      throw new Error(msg);
    };
    if (!this.handle[type] || !this.handle[type].length) {
      throw new Error(`${type} is not register`);
    };
    delete this.handle[type];
  }
  // 查询是否注册
  list(type = '') {
    if (!type) {
      throw new Error(`${type} is not exist`);
    };
    if (this.handle[type]) {
      return true;
    };
    return null;
  };
};

// let observer

// if (!observer) {
//   observer =
// }

module.exports = new Observer();
